function x=timecorr(x)
global xmin xmax res spres tol
%disp('corr')
h=diff(x);
ni=length(h);
%
%computing new mesh size
%
%dt=tol/2/sqrt(sum(h.*res(2,:).^2));
o=ones(size(spres));
spres=max(spres,tol*o);
hnew=(tol*ones(size(h))./(spres+eps*ones(size(spres)))/sqrt(ni)).^(2/5);
if min(hnew)<0.1*mean(hnew)
hnew=max(hnew,tol^2*ones(size(hnew)));
end
hnew=min(hnew,sqrt(tol)*ones(size(hnew)));
hnew=min(hnew,(xmax-xmin)/10*ones(size(hnew)));
%
%computing new mesh points
%
hnewmin=min(hnew);
hnewmax=max(hnew);
if hnewmin>0.3*hnewmax;
%mean(hnew)
%hnewmax-hnewmin<0.01*hnewmax
ni=ceil((xmax-xmin)/hnewmin);
x=[xmin:(xmax-xmin)/ni:xmax];
else
if hnew(ni)==hnewmin;
  target=x(ni+1);
else
  if hnew(1)==hnewmin;
    target=x(1);
  else
     i=1;
     while hnew(i)>hnewmin;
     i=i+1;
     end
     target=x(i)+h(i)/2;
  end
end
%
front=x(1);
xnew=front;
interval=1;
%
while front<target-eps;
%
   if front+hnew(interval)<x(interval+1);
     front=min(front+hnew(interval),target);
     xnew=[xnew,front];
   else
     if interval==ni;
       front=x(interval+1);
       xnew=[xnew,front];
     else
         if x(interval+1)-front>h(interval+1);
           front=min(x(interval+1),target);
           xnew=[xnew,front];
         else
           hmin=min(h(interval),h(interval+1));
           front=min(min(front+hmin,x(interval+2)),target);
           xnew=[xnew,front];
         end
         interval=interval+1;
     end
   end
%
end       %of outer while
%
leftmesh=xnew;
%
front=x(ni+1);
xnew=front;
interval=ni;
while front>target+eps;
%
   if front-hnew(interval)>x(interval);
     front=max(front-hnew(interval),target);
     xnew=[front,xnew];
   else
     if interval==1;
       front=x(1);
       xnew=[front,xnew];
     else
         if front-x(interval)>h(interval-1);
           front=max(x(interval),target);
           xnew=[front,xnew];
         else
           hmin=min(h(interval),h(interval-1));
           front=max(max(front-hmin,x(interval-1)),target);
           xnew=[front,xnew];
         end
         interval=interval-1;
     end
   end
%
end       %of outer while
%
x=[leftmesh,xnew(2:length(xnew))];
end
%meshsmoothing
nn=length(x);
for i=2:ni
x(i)=(x(i-1)+x(i+1))/2;
end
for i=ni:2;
x(i)=(x(i-1)+x(i+1))/2;
end


