function [ad,al,ar,b]=stiffload(x,d,Dd,c,r,f,g,k,bctype)
disp('stiff')
ni=length(x)-1;
h=x(2:ni+1)-x(1:ni);
%
%setting constant in streamline diffusion test quantity: v+chv'
%
csd=zeros(size(c));
if max(h-d./(abs(c)+eps))>0;
csd=c./(abs(c)+eps)/2;
disp('using streamline diffusion modification');
end
%
ad(2:ni+1)=d./h+c/2+r.*h/3+csd.*(-Dd+c+r.*h/2);
ad(1:ni)=ad(1:ni)+d./h-c/2+r.*h/3+csd.*(-Dd+c-r.*h/2);
al=-d./h-c/2+r.*h/6+csd.*(Dd-c+r.*h/2);
ar=-d./h+c/2+r.*h/6+csd.*(Dd-c-r.*h/2);
b(2:ni+1)=f.*(.5+csd).*h;
b(1:ni)=b(1:ni)+f.*(.5-csd).*h;
%
if bctype(2)==1
  ad(ni+1)=ad(ni+1)+k(2);
  b(ni+1)=b(ni+1)+g(2);
else
  b(ni)=b(ni)-ar(ni)*g(2);
  b=b(1:ni);
  ad=ad(1:ni);
  al=al(1:ni-1);
  ar=ar(1:ni-1); 
end
%
if bctype(1)==1
  ad(1)=ad(1)+k(1);
  b(1)=b(1)+g(1);
else
  b(2)=b(2)-al(1)*g(1);
  b=b(2:ni+bctype(2));
  ad=ad(2:ni+bctype(2));
  al=al(2:ni+bctype(2)-1);
  ar=ar(2:ni+bctype(2)-1);
end

